# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib2 import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import re
from xml.dom.minidom import parseString
import youku

def httpget(url):
	try:
		return urlopen(url).read()
	except:
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/youku.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误代码: youku 000')
		sys.exit(0)
	try:
		dom = parseString(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误代码: youku 001')
		sys.exit(0)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		item(title, url)
	xbmcplugin.endOfDirectory(handle)
else:
	url = sys.argv[2]
	o = urlparse(url)
	q = parse_qs(o.query)
	url = q['url'][0]
	if re.match('stack://.*', url):
		play('', url)
		sys.exit(0)
	o = urlparse(url)
	p = o.path.split('/')
	q = parse_qs(o.query)
	l = len(p)
	ret = {'success': False, 'code': 'youku 002'}
	if o.netloc == 'v.youku.com':
		if p[1] == 'v_show' and p[2][:3] == 'id_':
			ret = youku.play(url)
	if o.netloc == 'www.youku.com':
		if p[1] == 'show_page':
			ret = youku.show_page(url)
		if p[1] == 'show_episode':
			ret = youku.show_episode(url)
		if p[1] == 'playlist_show':
			ret = youku.playlist_show(url)
	if o.netloc == 'list.youku.com':
		if p[1] == 'show' and p[2][:3] == 'id_':
			ret = youku.list_show_id(url)
		if p[1] == 'show' and p[2] == 'episode':
			ret = youku.list_show_episode(url)
	if ret['success'] == False:
		xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		sys.exit(0)
	if 'item' in ret:
		for elem in ret['item']:
			item(elem['title'], elem['url'])
	if 'url' in ret:
		for elem in ret['url']:
			item(elem, 'stack://' + ' , '.join(ret['url'][elem]), False)
	xbmcplugin.endOfDirectory(handle)
